CalcDepth <- function(Wi1,Wi2,Wqt3,Hn,H1,thourT,Tsnow,Tx1,T,Told,rho_x1,rho_n) {
if (Wi2 > 0) {
	#######################Calculate full depth#################################
	if (Wi1 > 0) rho_x1 = rho_x1 else rho_x1 = rho_n
	
	c1 = 0.026
	c2 = 21.0
	c3 = 0.005
	c4 = 0.1
	if(Wqt3 == 0) c5 = 0 else c5 = 2
	rho_d = 0.15
	cx = 23.0
	if(rho_x1 <= rho_d) beta1=0 else beta1 = 1.0

	##Calculate Snow Temperature
	cs = 2.1*10^6*rho_x1+1.0*10^3*(1.0-rho_x1-Wqt3/(Wi2+Wqt3))+4.2*10^6*(Wqt3/(Wi2+Wqt3))
	lambda = 0.0442*exp(5.181*rho_x1)
	alpha = sqrt((pi*cs)/(lambda*2*3600*thourT))
	if (Told > 0 & T > 0) Ta = abs(T-Told) else if (Told > 0 & T < 0) Ta = T else Ta = T-Told
	
	if(Hn == 0 & H1 > 0) {
	Ts_ave = Tx1 + Ta*(1.0-exp(-alpha*0.01*H1))/(alpha*0.01*H1)
	A = c3*c5*thourT*exp(c4*Ts_ave-cx*beta1*(rho_x1-rho_d))
	B = c1*thourT*exp(0.08*Ts_ave-c2*rho_x1)
	rho_x2 = rho_x1*(exp(B*0.1*Wi1)-1)/(B*0.1*Wi1)*exp(A) #change in density of old snow over model timestep
	if (rho_x2 > 0.6) rho_x2 = 0.6
	rho_x3 = rho_x2*Wi2/(Wi2-Wqt3)
	H2 = 0.1*Wi2/rho_x3
	
	}else if (Hn > 0 & H1 > 0){
	Tx2 = Tx1 + Ta*((exp(-alpha*0.01*Hn)-exp(-alpha*0.01*H1))/(alpha*0.01*(H1-Hn)))
	Ts_ave = ((Tx2*H1)+(Tsnow*Hn))/(H1+Hn)
	A = c3*c5*thourT*exp(c4*Ts_ave-cx*beta1*(rho_x1-rho_d))
	B = c1*thourT*exp(0.08*Ts_ave-21*rho_x1)
	rho_x2 = rho_x1*(exp(B*0.1*Wi1)-1)/(B*0.1*Wi1)*exp(A) #change in density of old snow over model timestep
	if (rho_x2 > 0.6) rho_x2 = 0.6
	rho_x3 = H1*(rho_x2*Wi2/(Wi2-Wqt3))/(H1+Hn)+Hn*rho_n/(H1+Hn)
	H2 = 0.1*Wi2/rho_x3
	
	}else if (Hn > 0 & H1 == 0){
	Ts_ave = Tsnow
	H2 <- Hn
	rho_x3 = rho_n
	}else{
	Ts_ave = 0
	H2 = 0
	rho_x3 = 0
	}
}else{
H2 = 0
Ts_ave = 0
rho_x3=0
}
Depth_Parm <- c(H2,Ts_ave,rho_x3)	
return(Depth_Parm)
}