NewSnow <- function(T,Pn,PXTEMP) {

if(Pn > 0){
	#Compute density of new snow
	#rho_n is density of new snow (gm/cm^3)
	if (T <= -15) rho_n = 0.05 else rho_n = 0.05+0.0017*(T+15)^1.5
	Hn = (0.1*Pn)/rho_n #depth of new snow in cm
	
	#Calculate heat deficit
	#This calculates the amount of heat that must be added to new snowfall to bring it to 0 degrees C
	#DelDp is change in heat deficit due to snowfall (mm)
	#Tsnow is temperature of new snow (C)
	if (T < 0) {
	Tsnow = T
	DelDp = -(Tsnow*Pn)/(80/0.5)  #Temperature of new snow - (Latent heat of fusion/specific heat of ice)
	Train = PXTEMP #This is the temperature of rain
	}else {
	Tsnow = 0 
	DelDp = 0
	Train = T
	}
}else{
	#Compute Temperature of Rain
	if (T < 0) {
	Train = PXTEMP #This is the temperature of rain
	DelDp = 0
	Tsnow = T
	}else {
	Train = T
	DelDp = 0
	Tsnow = 0
	}
	Hn = 0
	rho_n = 0
	}	
Snow_Parms <- c(Hn,rho_n,Tsnow,DelDp,Train)
return(Snow_Parms)
}