###Compute fraction of P coming in as snow and rain###########
#Pn is water equivalent of new snow (mm)
#P is total precip input to model (mm)
#fs is fraction of precip in form of snow - determined by PXTEMP
#Pr is water equivalent of new rain (mm)
#Pfs is a pre-determined fraction of precip in form of snow
PrecipFract <- function(T,P,PXTEMP,SCF,Pfs,opt1) {
	if (opt1 == 0) {
	if (T < PXTEMP) {
	fs = 1 
	}else{
	fs = 0
	SCF=1
	}
	Pn <- P*fs*SCF  #water equivalent of new snow
	Pr <- P*(1-fs)*SCF  #incoming rain
	}else if (opt1 == 1){ #Do rain-snow elevation band here
	if (T < PXTEMP) {
	fs = 1 
	}else{
	fs = 0
	SCF=1}
	Pn <- P*fs*SCF  #water equivalent of new snow
	Pr <- P*(1-fs)*SCF  #incoming rain
	}else{ #passing a fraction value along with P for snow amount
	fs = Pfs
	Pn <- P*fs*SCF #water equivalent of new snow
	Pr <- P*(1-fs)*SCF  #incoming rain
	}
Prefact <- c(Pn,Pr)	
return(Prefact)
}