CalcTransmission <- function(Wi2,E,S1,thourP,As) {
########################Transmission of water through snow##################
#Transmission of water through snow cover
#Calculate lag time for excess water (in hours)

L = 5.33*(1.0-exp((-0.03*(thourP/6)*Wi2)/E)) #Lag time for excess water
E1 = E/L
Wis = Wi2/(25.4*As)
E1s = (E/L)/(25.4*As)
Omr_tot = 0

for (j in 1:6) {
	R = 1/(1+5*exp((-500*E1s)/Wis^1.3))
	Omr = (S1 + E1)*R
	S2 = S1+E1-Omr
	Omr_tot = Omr_tot + Omr
	S1 = S2
}

Trans_Parms <- c(S2,Omr_tot,E1)	
return(Trans_Parms)
}