setwd("C:/Users/Austin/Documents/R/SAC_SMA")

newmet <- array(NA,c(29220,3))
a <- paste("data_42.9375_-72.3125",sep="")
x <- scan(a, what=list(Temp=0, Precip=0, Wind=0))

for (i in 1:29220) {
lowbnd <- i*2-1
upbnd <- i*2
newmet[i,1] <- round(mean(x$Temp[lowbnd:upbnd]),2)
newmet[i,2] <- round(sum(x$Precip[lowbnd:upbnd]),2)
newmet[i,3] <- round(mean(x$Wind[lowbnd:upbnd]),2)
}
write.table(newmet,"keene_6hour.met", quote=FALSE, col.names=FALSE, row.names=FALSE, sep=" ")

###########################################################################################################
rm(list = ls(all = TRUE))
setwd("C:/Users/Austin/Documents/R/SAC_SMA")

#Major Parameters
#SCF - multiplying factor which adjusts precipitation that is determined to be in the form of snow
#MFMAX - maximum melt factor during non rain periods (june 21st mm/C*6hr)
#MFMIN - minimum melt factor during non-rain periods (december 21st 21st mm/C*6hr)
#UADJ - average wind function during rain-on-snow periods (mm/mb)
#SI - mean areal water equiv which there is always 100% areal snow cover (mm)
#Areal depletion curve - curve that defines areal extent of the snow cover as a function of how much of the original snow cover remains after significant bare ground shows up

#Minor Parameters
#NMF - Maximum negative melt factor
#TIPM - antecedent temperature index parameter (real - range is 0.01 to 1.0)
#PXTEMP - temp seperating rain from snow
#MBASE - base tempearture for snowmelt computations during non-rain periods (typically 0)
#PLWHC - percent liquid water holding capacity (max of 0.4)
#DAYGM - constant daily amount of melt taking place at soil-snow interface (mm/day)

#Read in precip and adjust
#P <- read.table("")
#T <- read.table("")
mets <- read.table("keene_6hour.met",header=FALSE) 
mets2 <- read.table("SnowDate.txt",header=FALSE) 
Pmet <- mets[,2]
Tmet <- mets[,1]
Nmet <- mets2[,1]

dtinc <- 0.25
opt1 <- 0 #choose opyion for determining precipitation fraction
tval <- length(Pmet) #Length of run
thourP <- 24*dtinc #timestep of snow model, so for six hours dtinc is 0.25 and thourP=6 (24*0.25)
thourT <- 24*dtinc
He <- 100  #elevation of basin (meters)
initsnow = 0 #specify initial snowpack in mm of swe, best to set to 0 and start model when no snow exists


#Define major parameters
SCF <- 1
MFMAX <- 1.2
MFMIN <- 0.4
UADJ <- 
SI <- 150
ADC <- 1
#Define Minor parameters
NMF <- 0.15
TIPM <- 0.5 #must be greater than 0 and less than 1
PXTEMP <- -1.5
MBASE <- 0
PLWHC <- 0.04 #Max of 0.4
DAYGM <- 1.0

#Setup state variables
Wi <- array(NA,tval) #water equivalent of ice portion (mm)
D <- array(NA,tval) #heat deficit
ATI <- array(NA,tval) #antecedent temperature index
Wqf <- array(NA,tval) #liquid water held by snow (mm)
H <- array(NA,tval) #depth of snow
Ts <- array(NA,tval) #average snow temperature
Wqt <- array(NA,tval)
Outflow <- array(NA,tval)
S <- array(NA,tval) #amount of lagged excess liquid
Eout <- array(NA,tval) #average hourly lagged excess water
Wt <- array(NA,tval) #average hourly lagged excess water
rho_xf <- array(NA,tval) #average hourly lagged excess water
####Not sure about these yet...
#Wmax <- array(NA,tval) #max water equiv that existed during accumulation
#Wns <- array(NA,tval) #water equivalent when new snowfall first occurs on partly bare area
#Ans <- array(NA,tval) #areal cover when new snowfall occurs on partly bare soil
#W100 <- array(NA,tval) #amount of water equivalent where areal cover drops below 100%
#Aadj <- array(NA,tval) #Ai value computed for use in depletion curve
#Tap #might not be needed


#########HOW PROGRAM IS BROKEN UP##########################
###########################################################
#1 Handle P and T input
#2 decide if P rain or snow or both
#3 if snow - accumulate goto 4, if rain, goto #8 
#4 energy exchange at snow air interface - areal extent
#5 compute snow cover deficit, if != 0.0 goto 7, else goto 6
#6 liquid water storage and transmission of water
#7 compute ground melt
#8 compute rain plus melt
#9 compute snow cover outflow


######FUNCTION DEFININTIONS#########################################################################################################
####################################################################################################################################
####################################################################################################################################

source("CalcPrecipFract.R")
source("CalcNewSnow.R")
source("CalcMeltStructure.R")
source("CalcRipeness.R")

##############BEGIN SNOW 17###########################################################################################
######################################################################################################################

for (i in 1:7305) {
#if (i==1) Ta = 0 else Ta = (Tmet[i]-Tmet[i-1]) #Start runs when no snow, then Ta = 0 is ok for first timestep
if (i==1) Wi1 = initsnow else Wi1 = Wi[i-1] #This is the current snow pack at begining of timestep
if (i==1) D1 = 0 else D1 = D[i-1] #This is the current snow pack at begining of timestep
if (i==1) ATI1 = 0 else ATI1 = ATI[i-1] #This is the current snow pack at begining of timestep
if (i==1) Wq = 0 else Wq = Wqf[i-1] #This is the current snow pack at begining of timestep
if (i==1) S1 = 0 else S1 = S[i-1] #This is the current snow pack at begining of timestep
if (i==1) H1 = 0 else H1 = H[i-1] #This is the current snow pack at begining of timestep
if (i==1) rho_x1 = 0 else rho_x1 = rho_xf[i-1] #This is the current snow pack at begining of timestep
if (i==1) Tx1 = 0 else Tx1 = Ts[i-1] #This is the current snow pack at begining of timestep
if (i==1) Told = 0 else Told = Tmet[i-1] #This is the current snow pack at begining of timestep

T <- Tmet[i]
P <- Pmet[i]
N <- Nmet[i]
##Determine Precipitation Type and Fraction
rain_snow <- PrecipFract(T,P,PXTEMP,SCF,Pfs,opt1)
Pn <- rain_snow[1]
Pr <- rain_snow[2]

#No New Snow and No Previous Snow##################################################################################################################################
#######################################################################################################################################################################
if (Wi1 == 0 & Pn == 0){
Wi[i] = 0
D[i] = 0
H[i] = 0
ATI[i] = 0
Wqf[i] = 0
Ts[i] = 0
Eout[i] = 0
Wqt[i] = 0
S[i] = 0
Wt[i] = 0
rho_xf[i] = 0
Wqt3 = 0
Outflow[i] = Pr
}else if (Wi1 == 0 & Pn > 0){
#New Snow and No Previous Snow################################################################################################################################
#######################################################################################################################################################################

Snow_Value <- NewSnow(T,Pn,PXTEMP)
Hn <- Snow_Value[1]
rho_n <- Snow_Value[2]
Tsnow <- Snow_Value[3]
DelDp <- Snow_Value[4]
Train <- Snow_Value[5]

#Adjust yesterdays snowpack (SWE) by whatever came in today
#This is solely from new snow and yesterday's snow and is only the ice portion of snow, in water equivalent
Wi[i] <- Pn
D[i] <- 0
Eout[i] <- 0
ATI[i] <- Tsnow
Wqf[i] <- 0
Wqt3 <- 0
Wqt[i] <- 0
Wt[i] <- Pn
Outflow[i] = 0
S[i] = 0	
#Do not calc depth here because depth is Hn and temp is Tsnow
#CalcDepth(Wi2,Wqt2,Hn,H1,thourT,Tsnow,Ta,Wix,rho_x,rho_n)
H[i] = Hn
Ts[i] = Tsnow
rho_xf[i] <- rho_n
	
}else if (Wi1 > 0 & Pn > 0) {
#New Snow and Previous Snow##################################################################################################################################
######################################################################################################################################################################

Snow_Value <- NewSnow(T,Pn,PXTEMP)
Hn <- Snow_Value[1]
rho_n <- Snow_Value[2]
Tsnow <- Snow_Value[3]
DelDp <- Snow_Value[4]
Train <- Snow_Value[5]

#Adjust yesterdays snowpack (SWE) by whatever came in today
#This is solely from new snow and yesterday's snow and is only the ice portion of snow, in water equivalent
Wi2 <- Pn + Wi1

#Determine melt of snow pack
Melt_Value <- MeltStructure(T,N,ATI1,He,Pr,thourP,thourT,Tsnow,Train,UADJ,MBASE,TIPM,MFMAX,MFMIN,PLWHC,Wi2)
Wi2 <- Melt_Value[1]
ATI2 <- Melt_Value[2]
Qw <- Melt_Value[3]
DelDt <- Melt_Value[4]

#Calculate Ripeness and store ATI value and replace ATI1 with current value of ATI (ATI2)
Ripe_Value <- CalcRipeness(Wi2,D1,DelDt,DelDp,Wq,ATI2,Qw,PLWHC,S1,thourP,DAYGM) 
Wi[i] <- Ripe_Value[1]
D[i] <- Ripe_Value[2]
Eout[i] <- Ripe_Value[3]
ATI[i] <- Ripe_Value[4]
Wqf[i] <- Ripe_Value[5]
Wqt3 <- Ripe_Value[6]
Wqt[i] <- Ripe_Value[6]
Wt[i] <- Ripe_Value[7]
Outflow[i] = Ripe_Value[8]	
S[i] = Ripe_Value[9]

Depth_Value <- CalcDepth(Wi1,Wi2,Wqt3,Hn,H1,thourT,Tsnow,Tx1,T,Told,rho_x1,rho_n)
H2 <- Depth_Value[1]
Ts_ave <- Depth_Value[2]
rho_xf[i] <- Depth_Value[3]
H[i] = H2
Ts[i] = Ts_ave


}else{ #(Wix > 0 & Pn = 0)
#No New Snow and Previous Snow###########################################################################################################################
##################################################################################################################################################################

Snow_Value <- NewSnow(T,Pn,PXTEMP)
Hn <- Snow_Value[1]
rho_n <- Snow_Value[2]
Tsnow <- Snow_Value[3]
DelDp <- Snow_Value[4]
Train <- Snow_Value[5]

#Adjust yesterdays snowpack (SWE) by whatever came in today
#This is solely from new snow and yesterday's snow and is only the ice portion of snow, in water equivalent
Wi2 <- Wi1  #Here Pn should be close to zero

#Determine melt of snow pack
Melt_Value <- MeltStructure(T,N,ATI1,He,Pr,thourP,thourT,Tsnow,Train,UADJ,MBASE,TIPM,MFMAX,MFMIN,PLWHC,Wi2)
Wi2 <- Melt_Value[1]
ATI2 <- Melt_Value[2]
Qw <- Melt_Value[3]
DelDt <- Melt_Value[4]

#Calculate Ripeness and store ATI value and replace ATI1 with current value of ATI (ATI2)
Ripe_Value <- CalcRipeness(Wi2,D1,DelDt,DelDp,Wq,ATI2,Qw,PLWHC,S1,thourP,DAYGM) 
Wi[i] <- Ripe_Value[1]
D[i] <- Ripe_Value[2]
Eout[i] <- Ripe_Value[3]
ATI[i] <- Ripe_Value[4]
Wqf[i] <- Ripe_Value[5]
Wqt3 <- Ripe_Value[6]
Wqt[i] <- Ripe_Value[6]
Wt[i] <- Ripe_Value[7]
Outflow[i] = Ripe_Value[8]	
S[i] = Ripe_Value[9]

Depth_Value <- CalcDepth(Wi1,Wi2,Wqt3,Hn,H1,thourT,Tsnow,Tx1,T,Told,rho_x1,rho_n)
H2 <- Depth_Value[1]
Ts_ave <- Depth_Value[2]
rho_xf[i] <- Depth_Value[3]
H[i] = H2
Ts[i] = Ts_ave
	
	}
}

######Program is Executed at this point...##########################

NH_Snow <- read.table("NH_Snow_VIC.txt",header=TRUE)
dH <- array(NA,1827)
dOut <- array(NA,1827)
dWi <-array(NA,1827)
drho <- array(NA,1827)
Pday <- array(NA,1827)


##Aggregate Snow data to daily for comparison###
for (i in 1:1827) {
lowbnd <- i*4-3
upbnd <- i*4
dH[i] <- round(mean(H[lowbnd:upbnd]),2)
dOut[i] <- round(sum(Outflow[lowbnd:upbnd]),2)
dWi[i] <- round(mean(Wi[lowbnd:upbnd]),2)
drho[i] <- round(mean(rho_xf[lowbnd:upbnd]),2)
Pday[i] <- round(sum(Pmet[lowbnd:upbnd]),2)
}

begs <- 700
ends <- 900
plot(dH[begs:ends]*2.54,type="l",col="blue",ylab="Snow Depth (cm)",xlab="Days from 12/1/1981")
points(dH[begs:ends]*2.54,col="blue")
lines(NH_Snow$Keene[begs:ends])
lines(Pday[begs:ends],col="green")
points(drho[begs:ends]*100)
legend("topleft",c("Model Depth (cm)","Observed Depth (cm)","Precip","Density"),lty=c(1,1,1,0),col=c("blue","black","green","black"),pch=c(1,-1,-1,1))

###Compute Areal Outflow#####
#Out_fin = (Out_tot*As)+((1.0-As)*(Pr))
#Wmax = 25
#if (Wmax > SI) Ai = SI else Ai = Wmax
# T
# P
# Wi[i]
# D[i]
# Eout[i]
# ATI[i]
# Wqf[i]
# Wqt2
# Wqt[i]
# Wt[i]
# Outflow[i]
# rho_xf[i]
# H[i]
# Ts[i]



plot(H[1:360],ylim=c(0,10),type="l")
lines(Outflow[1:360],col="purple")
points(Pmet[1:360],col="blue")
